/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension;

import org.fortiss.tooling.kernel.extension.data.ITopLevelElement;
import org.fortiss.tooling.kernel.service.IMigrationService;
import org.fortiss.tooling.kernel.service.base.IObjectAware;

/**
 * Interface for the migration provider implementations.
 * <P>
 * migration provider extensions are handled by {@link IMigrationService}.
 * 
 * @author mou
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating GREEN Hash: 644590FDA54780140699CE0595DCC8B2
 */
public interface IMigrationProvider extends IObjectAware<ITopLevelElement> {

	/**
	 * Determines whether migration provider is needed for the given
	 * model element.
	 */
	boolean needMigration(ITopLevelElement modelElement);

	/** Applies the provider to the given element. */
	void migrate(ITopLevelElement modelElement);
}
